% This is the About selection


AboutFig=figure('Units','Normalized','Position',[.4 .35 .5 .55],...
	'MenuBar','none',...
	'Name','About The Rotating Vector Demonstration',...
	'NumberTitle','off','Resize','on','UserData',['graph']);

TextFrame=uicontrol('Style','frame','Units','normalized',...
	'Position',[.03 .52 .94 .45]);

CloseIt=uicontrol('Style','pushbutton','Units','normalized',...
	'Position',[.5 .53 .43 .07],'String','Close this Window',...
	'Callback','close');

l1=['This program was developed by Nabeel B. Azar '];
l2=['in a project directed by Wilson J. Rugh, with the support '];
l3=['of the National Science Foundation and the Kenan Fund for '];
l4=['Undergraduate Education at The Johns Hopkins University.  '];
l5=['This program is based on ideas from the 1971 movie '];
l6=['"Harmonic Phasors II," produced by William H. Huggins '];
l7=['at The Johns Hopkins University.'];
CreditText=[l1,l2,l3,l4,l5,l6,l7];
Credits=uicontrol('Style','text','Units','normalized',...
	'Position',[.05 .63 .87 .33],'ForeGroundColor','k',...
	'HorizontalAlignment','left','String',CreditText);

%-------------------------------------------

subplot(2,1,2)
axis ([-1 181 0 1])
axis off
hold on
global SpeedFactor
incr=round(3/SpeedFactor);
numvalues=180/incr +1;
deg=(2*pi)/360;
points=zeros(2,numvalues);
xval=zeros(1,numvalues);
t=0;
for t=1:500		%  Up to 500 vectors
			%  if they wait long enough !!!


yold=0;
xold=0;
cntr=0;
line([0 0],[0 .8],'Color','b','EraseMode','none')
line([0 180],[.8 .8],'Color','b','EraseMode','none')
line([180 180],[.8 0],'Color','b','EraseMode','none')

	for x=0:incr:180;
		cntr=cntr+1;
		nvalue=[(1/(2*t-1)) * sin((2*t-1)*deg*x)];
		points(t,cntr)=nvalue;
		%------------------------
		% To draw the points		
		yval(cntr)=sum(points(:,cntr));		
		PrevLine(t,cntr)=line([xold, x],[yold, yval(cntr)],...
		'EraseMode','xor');
		yold=yval(cntr);
		xold=x;
		drawnow


	end
	%  We want to pause if fewer than 7
	% vectors.  If more, we want to hurry
	% up and watch it change to the square wave
	
	if t < 7
		pause(1)
	end

%-------------------------------
%  Is the figure window still there?
%  If not, it has been closed and
%  we don't need to continue execution
%
if gcf~=AboutFig
	break
end
%
%-------------------------------

	if t~=1
		delete(PrevLine(t-1,:))
	end

	set(PrevLine(t,:),'Color',[.5 .5 .5])



end
%----------------------------