%function stwin(speed)
function fserdem(speed)
%clear global % Need to keep the speed 
		% variable for later

global SpeedFactor

%Set up window
%close all
%home

%***************************************
StartTime=cputime;

%****************************

Title=['The Harmonic Phasor Demonstration'];

StartWindow=figure ('Units','normalized',... % 'Position',[eps,1-eps,1-eps, .001],...
	'NumberTitle','off','Name',Title,... %'MenuBar','none',...
	'Resize','off');

%***************************************************
%The manual entry window

OwnValues=uimenu('Label','Own &Values','CallBack','vnv');

%---------------------------------------
%Contents of the Intro Samples menu

IntroMenu=uimenu('Label','&Cosines');
	uimenu (IntroMenu,'Label','&cos (x)','CallBack','maninp(2)');
	uimenu (IntroMenu,'Label','&sin (x)','CallBack','maninp(3)');
	uimenu (IntroMenu,'Label','cos (x + 40 degrees)',...
		'CallBack','maninp(4)');


%-----------------------------------------
%Contents of Other Waveforms Menu

OtherMenu=uimenu('Label','&Other Waveforms');

	OddHarm=uimenu(OtherMenu,'Label','&Square Wave');
		uimenu (OddHarm,'Label','&3 Harmonics:  sin(x) + (1/3)sin(3x)','Callback','maninp(5)');
		uimenu (OddHarm,'Label','&5 Harmonics:    "   +(1/5)sin(5x)','CallBack','maninp(6)');
		uimenu (OddHarm,'Label','&7 Harmonics:    "   +(1/7)sin(7x)','CallBack','maninp(7)');
		uimenu (OddHarm,'Label','&23 Harmonics:  "  ...  +(1/23)sin(23)','CallBack','maninp(8)');

	Impulse=uimenu (OtherMenu,'Label','&Impulse Train');
		uimenu (Impulse,'Label','&1 Harmonics','CallBack','maninp(9.03)');
		uimenu (Impulse,'Label','&4 Harmonics','CallBack','maninp(9.05)');
		uimenu (Impulse,'Label','&7 Harmonics','CallBack','maninp(9.08)');
		uimenu (Impulse,'Label','&15 Harmonics','CallBack','maninp(9.16)');

	Saw=uimenu (OtherMenu,'Label','Sa&wtooth');
		uimenu(Saw,'Label','&3 Harmonics','CallBack','maninp(10.03)');
		uimenu(Saw,'Label','&5 Harmonics','CallBack','maninp(10.05)');
		uimenu(Saw,'Label','&8 Harmonics','CallBack','maninp(10.08)');
		uimenu(Saw,'Label','&16 Harmonics','CallBack','maninp(10.16)');


%-----------------------------------------
%Miscellaneous Items

Space=['                 '];
BlankSpace=uimenu('Label',Space);
CleaningUp=uimenu('Label','C&leaning Up');
	uimenu (CleaningUp,'Label','&Arrange','CallBack','arrange(10)');
	uimenu (CleaningUp,'Label','&Close all','Separator','on','CallBack','arrange(30)');
About=uimenu('Label','&About','Callback','about','Interruptible','on');
Exit=uimenu('Label','Exit','Position',[0],'CallBack','close all');
%-------------------

%***************************************

if nargin == 1
%	global SpeedFactor
	SpeedFactor=speed;

else	% Then go on with the test

%***************************************
testfig=figure ('Units','normalized', 'Position',[.1, .15,.8, .75],...
	'NumberTitle','off','Name','Speed Calibration',... %'MenuBar','none',...
	'Resize','off');
pause(1)
axis ([-5 185 -.8 1.2])
axis off
Please=['Please wait while the program speed is calibrated...'];
title(Please)
Wait=['In the meantime, enjoy this preview...'];
text('Units','data','Position',[40 0],'String',Wait)

hold on
incr=2;
numvalues=180/incr +1;
deg=(2*pi)/360;
points=zeros(2,numvalues);
xval=zeros(1,numvalues);

for t=1:5	%5 vectors

yold=0;
xold=0;
cntr=0;
line([0 0],[0 .8],'Color','b','EraseMode','none')
line([0 180],[.8 .8],'Color','b','EraseMode','none')
line([180 180],[.8 0],'Color','b','EraseMode','none')
	for x=0:incr:180;
		cntr=cntr+1;
		nvalue=[(1/(2*t-1)) * sin((2*t-1)*deg*x)];
		points(t,cntr)=nvalue;
		%------------------------
		% To draw the points		
		yval(cntr)=sum(points(:,cntr));		
		PrevLine(t,cntr)=line([xold, x],[yold, yval(cntr)],'EraseMode','xor'...
			);
		yold=yval(cntr);
		xold=x;
		drawnow


	end
	pause(1)
	if t~=1		% LASSE ANDRAT FRAN 0 till 1 !!!!!!!!!!!!!!!!!!!!!!!
		delete(PrevLine(t-1,:))
	end
	set(PrevLine(t,:),'Color',[.5 .5 .5])



end
%----------------------------
TimeElapsed=cputime-StartTime
%----------------------------	
pause(3)
title('') % This is to clear the axis title
cla
Where=['You may now use the demo by making a selection from above.'];
text('Units','data','Position',[10 .5],'String',Where)
pause (4)
delete (testfig)
%***************************************
MyComputer=22;
TheirsVsMine=MyComputer/TimeElapsed; 
SpeedFactor=(round(10*TheirsVsMine))/10
% The 10 is because I wanted 1 decimal of
% accuracy after I round

%**********************************************

end	% end of the speedfactor determination
%**********************************************

%clear	% to clear the variables that we didn't
	% clear in the clear global at the 
	% beginning.  Done this way so that the
	% variable speed was retained
