function fsplot1(C,val)
%
global AX cols1 lw
msize1=6;	% Markersize, Changed marker by Lasse A. 970824
msize2=18;

% Om val==11: x(t) i AX(1,1)
% Om val==12: Ampl.spektrum i AX(1,2)
% Om val==21: x(t) med frre deltoner i AX(2,1)
% Om val==22: FasspektrCm i AX(2,2)

if val==11
 axes(AX(1,1))
 T=1/C(513);
 antper=2;
 t=T*antper/512*(0:511);
 v=real(ifft(512*C(1:512)));
 x=[];

% Lasse A's comments:
% -------------------
% The following may not work so well on signals which only contain
% very high frequency components.
% In such a situation, the result will be like a envelop detector.
% The right signal is be plotted correctly if an *odd* number of periods
% are plotted.
% NOTE: Here, 'antper' equals the number of *periods* that are to be plotted.
% -------------------------------------------------------------------------
 for i=1:antper, x=[x v(rem(i*512,antper)+1:antper:512)]; end
 d=(max(x)-min(x))/2;
 e=(max(x)+min(x))/2;
 xpl=plot(t,x);
 set(xpl,'color',cols1,'linewidth',lw)
 axis([0 t(length(t)) e-1.1*d e+1.1*d]);
 hand=xlabel('Tid (s)');
 set(hand,'fontsize',14)
 hand=title('Aktuell signal, x(t)');
 set(hand,'fontsize',16)
 grid on
 set(AX(1,1),'fontsize',14)




elseif val==21
 axes(AX(2,1))





elseif val==12
 C=round(1000.*C)./1000;
 axes(AX(1,2))
 fmax=30; 
 A=[real(C(1)) 2*abs(C(2:fmax+1))];
 dotpl=plot(0,A(1),'.');
 set(dotpl,'MarkerSize',msize2,'color',cols1)
 axis([0 fmax 1.1*min([A 0]) 1.1*max([A 0])])
 hold on
 for i=1:fmax+1,
  dotpl=plot(i-1,A(i),'.');
  set(dotpl,'MarkerSize',msize2,'color',cols1)
  hpl=plot([i-1 i-1],[A(i) 0]);
  set(hpl,'linewidth',lw,'color',cols1)
 end
 grid on
 hand=xlabel('Deltonsnummer');
 set(hand,'fontsize',14)
 hand=title(['Amplitudspektrum, X_k  ( f_1=' num2str(C(513)) ' Hz )']);
 set(hand,'fontsize',14)
 hold off
 set(AX(1,2),'fontsize',14)
 
elseif val==22
  C=round(100.*C)./100;
  axes(AX(2,2))
  fmax=30; 
  A=[real(C(1)) 2*abs(C(2:fmax+1))];
  fi=180/pi*(pi/2+angle(C(1:fmax+1)));
  a=find(fi>180);
  fi(a)=fi(a)-360;
  a=find(A==0);
  fi(a)=zeros(size(a));
  fi=fi(2:length(fi));
  dotpl=plot(1,fi(1),'.');
  set(dotpl,'MarkerSize',msize2,'color',cols1)
  axmin=1.1*min([fi 0]);
  axmax=1.1*max([fi 0]);
  if axmin==axmax, axmin=-90; axmax=90; end
  axis([0 fmax axmin axmax])
  hold on
  for i=1:fmax,
   dotpl=plot(i,fi(i),'.');
   set(dotpl,'MarkerSize',msize2,'color',cols1)
   hpl=plot([i i],[fi(i) 0]);
   set(hpl,'linewidth',lw,'color',cols1)
  end
  grid on
  hand=xlabel('Deltonsnummer');
  set(hand,'fontsize',14)
  hand=title('Fasspektrum, \phi_k');
  set(hand,'fontsize',16)
  hold off
  set(AX(2,2),'fontsize',14)
end






