function lineexpx(action,Func,hand2);
% LINEEXPX - Som LINEEXP, men expanderar bara i x-led
% 
% Lasse Alfredsson, Aug-Sept 1997

global LINEEXP LINEXDATA


if nargin==1, Func=''; hand2=[]; end	% Ingen funktion anropas

if strcmp(action,'down'),
    % assumes that a line was clicked 

    line_handle = gco;
    set(line_handle,'EraseMode','xor');
    ax = gca;
    axes(ax);

    % Obtain coordinates of mouse click location in axes units
    pt=get(gca,'currentpoint');
    x=pt(1,1);
    y=pt(1,2);

    % find closest point on line to mouse click loc (call it fixed_x, fixed_y)
    line_x=get(line_handle,'XData');
    line_y=get(line_handle,'YData');
    LINEXDATA=line_x;
    dist=(line_x-x).^2 + (line_y-y).^2;
    [temp,i]=min(dist);

    set(line_handle,'LineStyle','--');	% Eller andra farg?
    drawnow;

    LINEEXP(1)=line_x(1);	% xmin
    LINEEXP(2)=line_x(length(line_x));	% xmax
    LINEEXP(3)=-Inf;	 
    LINEEXP(4)= Inf;
    LINEEXP(5)=line_x(i);	% fixed_x
    LINEEXP(7)=line_handle;	% Handtag till aktuell linje
    LINEEXP(8)=ax;		% Handtag till aktuell axes

    set(gcf,'WindowButtonMotionFcn', ...
	sprintf('lineexpx(''move'',''%s'',%19.16f)',Func,hand2));
    set(gcf,'WindowButtonUpFcn', ...
	sprintf('lineexpx(''up'',''%s'',%19.16f)',Func,hand2));

    watchoff(gcf)

    eval([Func '(' sprintf('%19.16f,%19.16f,%19.16f',ax,line_handle,hand2) ')'])


elseif strcmp(action,'move'),
    xmin        = LINEEXP(1);
    xmax        = LINEEXP(2);
    fixed_x     = LINEEXP(5);
    line_handle = LINEEXP(7);
    ax          = LINEEXP(8);

    axes(ax)
    line_x=LINEXDATA;
    tidmin=line_x(1);
    tidmax=line_x(length(line_x));

    pt=get(gca,'currentpoint');
    x=pt(1,1);

    axlim=axis;
    xquot=x/fixed_x;	% Relativ andring i x-led
    tidminny=tidmin*xquot;
    tidmaxny=tidmax*xquot;
    if tidmaxny<axlim(2), xquot=axlim(2)/tidmax; 1, end
%    if tidminny>axlim(1), xquot=axlim(1)/tidmin; 2, end

    nyxdata=line_x*xquot;
    set(line_handle,'XData',nyxdata);
 
    eval([Func '(' sprintf('%19.16f,%19.16f,%19.16f',ax,line_handle,hand2) ')'])

 
elseif strcmp(action,'up'),
    xmin        = LINEEXP(1);
    xmax        = LINEEXP(2);
    fixed_x     = LINEEXP(5);
    line_handle = LINEEXP(7);
    ax          = LINEEXP(8);

    axes(ax)
    line_x=LINEXDATA;
    tidmin=line_x(1);
    tidmax=line_x(length(line_x));

    pt=get(gca,'currentpoint');
    x=pt(1,1);

    axlim=axis;
    xquot=x/fixed_x;	% Relativ andring i x-led
    tidminny=tidmin*xquot;
    tidmaxny=tidmax*xquot;
    if tidmaxny<axlim(2), xquot=axlim(2)/tidmax; end
%    if tidminny>axlim(1), xquot=axlim(1)/tidmin; end


    set(gcf,'WindowButtonMotionFcn','');
    set(gcf,'WindowButtonUpFcn','');

    set(line_handle,'linestyle','-');

    nyxdata=line_x*xquot;
    set(line_handle,'XData',nyxdata);

    drawnow;

    eval([Func '(' sprintf('%19.16f,%19.16f,%19.16f',ax,line_handle,hand2) ')'])


end
