function pslide
% This function sets up the phase slider
% to create a delay, which can be made 
% proportional to the frequency or
% simple by an added constant

global Psbox Pinfoval PropPha ConstPha

Pfig=figure('Name','Phase Shift','NumberTitle','off',...
	'MenuBar','none','Units','normalized',...
	'Position',[.05 .50 .45 .28],'Resize','off');



Psbox=uicontrol('Style','slider','units','normalized',...
	'Position',[.05 .6 .9 .2],'Min',-180,'Max',180,...
	'Value',0,'CallBack','pread(0)' );

Ptext1=uicontrol('style','Text','units','normalized',...
	'Position',[.05 .8 .1 .15],...
	'String','-180','BackGroundColor','k',...
	'ForeGroundColor','c');
Ptext2=uicontrol('style','Text','units','normalized',...
	'Position',[.85 .8 .1 .15],...
	'String','+180','BackGroundColor','k',...
	'ForeGroundColor','c');
Ptext3=uicontrol('style','Text','units','normalized',...
	'Position',[.45 .8 .1 .15],...
	'String','0','BackGroundColor','k',...
	'ForeGroundColor','c');


Pinfoval=uicontrol('Style','Edit','units','normalized',...
	'Position',[.8 .35 .1 .12],...
	'String',num2str(get(Psbox,'Value')),...
	'ForeGroundColor','w',...
	'CallBack','pread(.5)' );

PropPha=uicontrol('Style','radio','units','normalized',...
	'Position',[.05 .32 .57 .18],...
	'String','Proportional to Frequency',...
	'Value',1,'CallBack','pread(2)');

ConstPha=uicontrol('Style','radio','units','normalized',...
	'Position',[.05 .05 .57 .18],...
	'String','Constant Phase',...
	'Value',0,'CallBack','pread(1)');
ApString=['Click to apply.'];
Apply=uicontrol('Style','pushbutton','units','normalized',...
	'Position',[.72 .05 .25 .25],...
	'String',ApString,'CallBack','pread(3)');



