function window(type)

% Type    What it does
%  1      Fejer Window
%  2      Hamming Window

% To get the frequencies and magnitudes

global FreqInfo MagInfo
global numvectors
global TitleInfo
for i=1:numvectors
	Freq(i)=str2num( get(FreqInfo(i),'String') );
	Mag(i)=str2num( get(MagInfo(i),'String') );
end

% To find N
% If (number of harmonics)=(2*numvectors)-1,
% then they probably are using a square wave approximation
% where N is actually the last unused even harmonic.
% For those calculations, we will let N=N+1
if TitleInfo(1,1)==(2*numvectors)-1
	N=max(Freq)+1;
else
	N=max(Freq);
end

%--------------------------------------------------------------
%--------------------------------------------------------------
if type==1
%--------------------------------------------------------------
% Fejer Windowing Function
% (N-k)/N
% N is the highest frequency
% k is the frequency of that term
	for i=1:numvectors
		weight=(N-Freq(i))/N;
		set( MagInfo(i),'String',rats( (weight*Mag(i)) ));
	end

TitleInfo(4,1)=1;
end % of type 1
%--------------------------------------------------------------

%--------------------------------------------------------------
%--------------------------------------------------------------
if type==2
%--------------------------------------------------------------
% Hamming Windowing Function
% (0.54 + 0.46cos(pi*k/N)
% N is the highest frequency
% k is the frequency of that term

	for i=1:numvectors
		weight=0.54+0.46*cos(pi*Freq(i)/N);
		set( MagInfo(i),'String',num2str( (weight*Mag(i)) ));
	end

TitleInfo(4,2)=1;
end % of type 2
%--------------------------------------------------------------
	