function bilindem

global AX WSLIDER Hwax Hwhand w0 w wmin wmax ww W0 Wbilhand W1text

axesdef(9,'Bilinjr transformation, Lgpassfilter')
uimenu('Label','            ');
fom = uimenu('Label','Brja om !!');
      uimenu(fom, 'Label','G till KRETSDEMO2', 'callback','clf, kretsdemo2(1)');
      uimenu(fom, 'Label','Bilinjr transformation igen', 'callback','bilindem');

wWaxpos=get(AX(1,1),'position');
Hwax=axes('Units','normal', ...
   	  'Position',[wWaxpos(1)+0.3*wWaxpos(3) wWaxpos(2) 0.7*wWaxpos(3) 0.3*wWaxpos(4)],'box','off');
HWax=axes('Units','normal', ...
   	  'Position',[wWaxpos(1) wWaxpos(2)+0.3*wWaxpos(4) 0.3*wWaxpos(3) 0.7*wWaxpos(4)],'box','off');

% set(Hwax,'visible','off')
% set(HWax,'visible','off')

w0=100;
wmax=400;
wmin=round(-3/7*wmax);
ww=wmin:wmax;
w=0:wmax;

Hw=1./sqrt(1+(w/w0).^6);	% Butterworth, n=3, w_0 = 100
W0=2*pi*0.35;			% Theta_0 = 0.35
gamma=w0/tan(W0/2);
% W=(0:300)*pi/300;		% 0 < W < pi
% HW=1./sqrt(1+(W/W0).^6);	% Tidsdiskreta motsvarigheten med Theta_0 = 0.35
wbil=logspace(.01,5,300);
W=2*atan(wbil/gamma);
HW=1./sqrt(1+(wbil/w0).^6);	% Tidsdiskreta motsvarigheten med Theta_0 = 0.35


axes(HWax)
HWhand=plot(HW,W,'b');
axis([0 1.5 0 pi])
grid on
set(HWax,'xtick',[1/sqrt(2) 1])
set(HWax,'xticklabel',{'1/sqrt(2)  ', '1'})
set(HWax,'ytick',W0)
set(HWax,'yticklabel','')
yl=ylabel('Normerad vinkelfrekvens,  \Omega  [rad]');
ylpos=get(yl,'position');
set(yl,'position',[ylpos(1)*2 1/7*pi ylpos(3)])
text(0.2,0.8*W0,'|H(\Omega)|','color','b','fontsize',18)

axes(Hwax)
plot(w,Hw,'b','erasemode','xor');
hold on
Hwhand=plot(w,Hw,'r','erasemode','xor','visible','off');
axis([0 wmax 0 1.5])
grid on
set(Hwax,'xtick',w0)
set(Hwax,'xticklabel','')
set(Hwax,'ytick',[1/sqrt(2) 1])
set(Hwax,'yticklabel',{'1/sqrt(2)', '1'})
text(1.2*w0,1.2,'|H(\omega)|','color','b','fontsize',18)

axes(AX(1,1))
T=W0/w0;
sampcol='m';
plot(ww,ww*T,sampcol,'erasemode','xor')
hold on
plot(ww,2*atan(ww/gamma),'b','erasemode','xor');
Wbilhand=plot(ww,2*atan(ww/gamma),'r','erasemode','xor','visible','off');
grid on
axis([wmin wmax -3/7*pi pi])
set(AX(1,1),'xtick',[0 w0 ])
set(AX(1,1),'xticklabel',{'0', 'wo'})
set(AX(1,1),'ytick',[0 W0 pi])
set(AX(1,1),'yticklabel',{'0', 'Wo', 'pi'})

xlabel('Vinkelfrekvens,   \omega  [rad/s]   ')
title('Bilinjr transformation,     H[z] = H(s)|s=\gamma(z-1)/(z+1)  ;       H[\Omega] = H(\omega)|\omega=\gamma tan(\Omega/2)')

plot([wmin wmax],[0 0],'k','linewidth',1.5)
plot([1 1],[-3/7*pi pi],'k','linewidth',1.5)
text(w0/8,.9*pi,'\Omega_0 = \omega_0T','color',sampcol,'fontsize',18)
text(1.7*w0,.6*W0,'\Omega = 2arctan(\omega/\gamma) ;  \gamma = \omega_0/ tan(\Omega_0/2)','color','b','fontsize',18);
W1text=text(1.7*w0,.4*W0,'\Omega = 2arctan(\omega/\gamma) ;  \gamma = \omega_1/ tan(\Omega_0/2)','color','r','fontsize',18,'visible','off');


axes(HWax)
axes(Hwax)
OHfigure2

Hwaxpos=get(Hwax,'position');
WSLIDER=uicontrol('style','slider','units','normal', ...
	'pos',[Hwaxpos(1)+Hwaxpos(3)/30 Hwaxpos(2)+Hwaxpos(4) Hwaxpos(3)*(1-1/30) .04], ...
	'sliderstep',[0.1 0.2],'min',wmax/13,'max',.95*wmax,'value',w0, ...
	'callback','bilinslide');


